/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelRestrictions = {};
panelRestrictions.localization = {};
/****************************/

// Panel details
var panelName = "Restrictions";
panelRestrictions._panel = $("#pnl" + panelName);

// Localizations
panelRestrictions.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelRestrictions.localization, localizations.panels[panelName]);

// Interface methods
panelRestrictions.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelRestrictions.bindData);
	panelRestrictions.bindEvents();
}

panelRestrictions.clearForm = function(panel)
{
	panel = panel || panelRestrictions._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).closest("div#generateKeyPanel").length>0)return;
		if($(this).attr("type")=="checkbox")
		{
			if($(this).closest("td").is(".checkboxArea"))return;
			userManager.UI.checkUnchekInput($(this));
		}
		else
		{
			$(this).val("");
		}
	});
}

panelRestrictions.bindData = function(userInfo, jsonDeep, panel)
{
	var dataPanel = panel || panelRestrictions._panel;
	panelRestrictions.clearForm(dataPanel);
	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(panelRestrictions._panel, userInfo.user, false, panel);

		if($("#fileEncryptionKey", panelRestrictions._panel).val() != "")
			$(".oldEncryption", panelRestrictions._panel).show();
		else
			$(".oldEncryption", panelRestrictions._panel).hide();

		var dataInheritedFrom = false;
		var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(userInfo.user, "day_of_week_allow"));
		var value = curData.value;
		dataInheritedFrom = curData.inherit || dataInheritedFrom;
		var daysAllowed = value.split("");
		for(var i=0;i<daysAllowed.length;i++)
		{
			var dayCheck = $("#day" + daysAllowed[i], dataPanel);
			userManager.UI.checkUnchekInput(dayCheck, true);
		}
		if(!panel)
			userManager.data.setInheritPropertyOfSection($("#day1", dataPanel), "day_of_week_allow", true);
		userManager.methods.showInheritValueLabel($("#day1", dataPanel), dataInheritedFrom);

		dataInheritedFrom = false;
		curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(userInfo.user, "allowed_protocols"));
		value = curData.value;
		dataInheritedFrom = curData.inherit || dataInheritedFrom;
		var protocolsAllowed = value.split(",");
		for(var i=0;i<protocolsAllowed.length;i++)
		{
			var curProto = protocolsAllowed[i].split(":");
			if(curProto.length>0)
			{
				if(!curProto[1])
					curProto[1] = 0;

				if(curProto[0].length && curProto[0].length>0)
				{
					var protoCheck = $("#proto_" + curProto[0], dataPanel);
					userManager.UI.checkUnchekInput(protoCheck, true);
					$("#proto_" + curProto[0] + "_val", dataPanel).val(curProto[1]);
				}
			}
		}
		panelRestrictions._panel.find("#maxConnectionsPerProtocolSettings").find("input.checkOptions").trigger("change");
		if(!panel)
			userManager.data.setInheritPropertyOfSection($("#proto_ftp", dataPanel), "allowed_protocols", true);
		userManager.methods.showInheritValueLabel($("#proto_ftp", dataPanel), dataInheritedFrom);

		//Binding IP Restrictions
		var IPRestrictions = $("#IPRestrictions", dataPanel).empty();
		if(userInfo.user.ip_restrictions)
		{
			userManager.methods.rebuildSubItems(userInfo.user.ip_restrictions, "ip_restrictions");
			userManager.UI.multiOptionControlDataBind(userInfo.user
				, "ip_restrictions"
				, $("#IPRestrictions", dataPanel)
				, function addNewButton(curItem){
						var type = curItem.type;
						var startip = curItem.start_ip;
						var stopip = curItem.stop_ip;
						var bannedIP = type + startip + "," + stopip;
						return $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
					}
			, !panel);
		}
		if(!panel)
			userManager.data.setInheritPropertyOfSection(IPRestrictions, "ip_restrictions", true);
		userManager.UI.panelsPostbindEvent(dataPanel, panel);
	}
}

panelRestrictions.validateMaxConnectionValue = function(val)
{
	if(!userManager.methods.isNumeric(val))
	{
		return "Please enter numeric value for max connections allowed : ";
	}
	else
	{
		var count = parseInt(val);
		if(count>0  && count<8)
		{
			return "Please enter value either 0 or 8 and higher for max connections allowed : ";
		}
	}
	return false;
}

panelRestrictions.bindEvents = function()
{
	userManager.UI.togglePanels(panelRestrictions._panel);
	$(".checkboxArea>input[type='checkbox']", panelRestrictions._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelRestrictions.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	var settingPanel = panelRestrictions._panel.find("#maxConnectionsPerProtocolSettings");
	settingPanel.find("input.countLimit").change(function(){
		var input = $(this);
		var msg = panelRestrictions.validateMaxConnectionValue(input.val());
		if(msg)
		{
			jPrompt(msg, "0", "Max connections allowed for " + input.parent().prev().prev().text(), function(value){
				if(value != null)
					input.val(value).change();
				else
					input.val(0);
				panelRestrictions._panel.trigger("changed");
			});
		}
	});

	settingPanel.find("input.checkOptions").change(function(){
		if(!$(this).is(":checked"))
		{
			$(this).closest("td").find("input[type='text']").val(0).attr("disabled", "disabled").addClass("ui-state-disabled disableValidation");
		}
		else
		{
			$(this).closest("td").find("input[type='text']").removeAttr("disabled", "disabled").removeClass("ui-state-disabled disableValidation");
		}
	});

	$("#expire_password_days", panelRestrictions._panel).bind("textchange", function(){
		var val = $(this).val();
		if(userManager.methods.isNumeric(val))
		{
			val = parseInt(val);
		}
		else
		{
			if(val.length>0)
				$(this).val(0);
			val = 0;
		}
		var myDate = new Date();
		myDate.setDate(myDate.getDate() + val);
		$("#expire_password_when", panelRestrictions._panel).html(myDate.format('mm/dd/yyyy hh:nn:ss a/p'));
		panelRestrictions._panel.trigger("changed");
	});

	$("#btnExpireNow", panelRestrictions._panel).click(function(){
		var myDate = new Date();
		$("#expire_password_when", panelRestrictions._panel).html(myDate.format('mm/dd/yyyy hh:nn:ss a/p'));
		panelRestrictions._panel.trigger("changed");
		return false;
	});

	$("#quickSetExpirationTime", panelRestrictions._panel).click(function(){
		var input = $("#account_expire", panelRestrictions._panel);
		var selDate = input.datepicker("getDate");
		var myDate = new Date();
		var defaultDays = 1.5;
		if(selDate)
		{
			var t2 = selDate.getTime();
			var t1 = myDate.getTime();
			defaultDays = parseInt((t2-t1)/(24*3600*1000)) + 1;
		}
		jPrompt("Enter the number of days from now until this account expires : ", defaultDays, "Input", function(value){
			var days = parseInt(value);
			if(days != null && days != NaN)
			{
				if (days == NaN) days = 0;
				if (days > 0) {
					myDate.setDate(myDate.getDate() + days);
					input.datepicker( "setDate" , myDate );
				}
				panelRestrictions._panel.trigger("changed");
			}
		});
		return false;
	});

	var IPRestrictions = $("#IPRestrictions", panelRestrictions._panel);
	$("a#addIPRestriction", panelRestrictions._panel).click(function(evt){
		var beforeAfter =  "";
		jPrompt("Insert before/after selection?", beforeAfter, "CrushFTP IP Insert", function(value){
			beforeAfter = value;
			if(beforeAfter != null)
			{
				var allowDeny = "";
				function allowDenyEntry()
				{
					jPrompt("Choose one :", allowDeny, "CrushFTP IPs", function(value){
						allowDeny = value;
						if(allowDeny)
						{
							var startIP = "";
							function startIPEntry()
							{
								jPrompt("Please enter a starting IP:", startIP, "CrushFTP IPs", function(value){
									startIP = value;
									if(startIP == null)
										return;
									if(!userManager.methods.isValidIP(startIP))
									{
										jAlert("Invalid starting IP - Address!!", "Message", function(){
										startIPEntry();
										});
									}
									else
									{
										var stopIP = startIP;
										function stopIPEntry()
										{
											jPrompt("Please enter a stopping IP:", stopIP, "CrushFTP IPs", function(value){
												stopIP = value;
												if(stopIP == null)
													return;
												if(!userManager.methods.isValidIP(stopIP))
												{
													jAlert("Invalid stopping IP - Address!!", "Message", function(){
													stopIPEntry();
													});
												}
												else
												{
													var bannedIP = allowDeny + startIP + "," + stopIP;
													var newControl = $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
													newControl.data("controlData", {
														start_ip:startIP,
														type:allowDeny,
														stop_ip:stopIP
													});

													if(beforeAfter == "After")
													{
														IPRestrictions.append(newControl);
													}
													else
													{
														IPRestrictions.prepend(newControl);
													}

													if(newControl)
													{
														newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
														newControl.addClass("ui-widget-header").addClass("ui-selected");
													}
													panelRestrictions._panel.trigger("changed");
												}
											});
										}
										stopIPEntry();
									}
								});
							}
							startIPEntry();
						}
						else if(fieldName != null)
						{
							allowDenyEntry();
						}
					}, ["A|Allow", "D|Deny"]);
				}
				allowDenyEntry();
			}
		}, ["Before", "After"]);
		return false;
	});

	$("a#removeIPRestriction", panelRestrictions._panel).click(function(){
		userManager.UI.removeItem(IPRestrictions);
		panelRestrictions._panel.trigger("changed");
		return false;
	});

	$("a#editIPRestriction", panelRestrictions._panel).click(function(evt, control){
		var selected = IPRestrictions.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			var controlData = selected.data("controlData");
			if(!controlData)return;
			var allowDeny = controlData.type;
			function allowDenyEntry()
			{
				jPrompt("Choose one :", allowDeny, "CrushFTP IPs", function(value){
					allowDeny = value;
					if(allowDeny)
					{
						var startIP = controlData.start_ip;
						function startIPEntry()
						{
							jPrompt("Please enter a starting IP:", startIP, "CrushFTP IPs", function(value){
								startIP = value;
								if(!userManager.methods.isValidIP(startIP))
								{
									jAlert("Invalid starting IP - Address!!", "Message", function(){
									startIPEntry();
									});
								}
								else
								{
									var stopIP = controlData.stop_ip;
									function stopIPEntry()
									{
										jPrompt("Please enter a stopping IP:", stopIP, "CrushFTP IPs", function(value){
											stopIP = value;
											if(!userManager.methods.isValidIP(stopIP))
											{
												jAlert("Invalid stopping IP - Address!!", "Message", function(){
												stopIPEntry();
												});
											}
											else
											{
												var bannedIP = allowDeny + startIP + "," + stopIP;
												var newControl = $("<li class='ui-widget-content' bannedIP='"+bannedIP+"'>"+bannedIP+"</li>");
												selected.replaceWith(newControl);
												newControl.data("controlData", {
													start_ip:startIP,
													type:allowDeny,
													stop_ip:stopIP
												});
												if(newControl)
												{
													newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
													newControl.addClass("ui-widget-header").addClass("ui-selected");
													panelRestrictions._panel.trigger("changed");
												}
											}
										});
									}
									stopIPEntry();
								}
							});
						}
						startIPEntry();
					}
					else if(fieldName != null)
					{
						allowDenyEntry();
					}
				}, ["A|Allow", "D|Deny", "D|Ban"]);
			}
			allowDenyEntry();
		}
		return false;
	});

	$("a.serverFilePickButton", panelRestrictions._panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					var elem = $("#" + curElem.attr("rel"), panelRestrictions._panel);
					if(curElem.attr("rel") == "ssh_public_keys" && elem.val().length>0)
					{
						elem.val($.trim(elem.val() + "\n"+ selectedPath)).trigger("change");
					}
					else
					{
						elem.val(selectedPath).trigger("change");
					}
					panelRestrictions._panel.trigger("changed");
				}
			});
			return false;
		});
	});

	$("a#generateFileKey", panelRestrictions._panel).click(function(){
		userManager.methods.performServerAction($("a#generateFileKey", panelRestrictions._panel),
			{
				command : "generateFileKey",
				keyPath : $("#fileEncryptionKey", panelRestrictions._panel).val()
			}
		, "Generate encryption key :");
		return false;
	});

	$("#removeOldEncryptionMethod", panelRestrictions._panel).unbind().click(function(){
		$("#fileEncryptionKey", panelRestrictions._panel).val("").trigger("change");
		if($("#fileEncryptionKey", panelRestrictions._panel).val()!="")
		{
			$(".oldEncryption", panelRestrictions._panel).show();
		}
		else
		{
			$(".oldEncryption", panelRestrictions._panel).hide();
		}
		return false;
	});

	$("#restrictions_pgpEncryptionGenerateButton").unbind().click(function () {
		if ($("#restrictions_pgpPivateKeyPathGenerate").val().indexOf(".key") < 0)
		{
			$("#restrictions_pgpPivateKeyPathGenerate").val($("#restrictions_pgpPivateKeyPathGenerate").val()+"private.key");
		}
		var obj = {
			command: "pgpGenerateKeyPair",
			pgpCommonNameGenerate: userManager.methods.htmlEncode($("#restrictions_pgpCommonNameGenerate").val()),
			pgpKeySizeGenerate: $("#restrictions_pgpKeySizeGenerate").val(),
			pgpKeyDaysGenerate: $("#restrictions_pgpKeyDaysGenerate").val(),
			pgpPrivateKeyPasswordGenerate: userManager.methods.htmlEncode($("#restrictions_pgpPrivateKeyPasswordGenerate").val()),
			pgpPivateKeyPathGenerate: userManager.methods.htmlEncode($("#restrictions_pgpPivateKeyPathGenerate").val()),
			random: Math.random()
		};
		$.ajax({
			type: "POST",
			url: userManager.ajaxCallURL,
			data: obj,
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				errorThrown = errorThrown || "pgpGenerateKeyPair failed";
				userManager.UI.growl("Error : ", errorThrown, true, true);
			},
			success: function (msg) {
				var responseText = msg;
				try {
					var response = msg.getElementsByTagName("response");
					response = userManager.data.getTextContent(response[0]).textContent;
					alert(response);
				} catch (ex) {}
			}
		});
		return false;
	});
}

panelRestrictions.generateXML = function()
{
	var xml = "";

	//General items
	panelRestrictions._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	xml += "\r\n<expire_password_when>"+$("#expire_password_when", panelRestrictions._panel).text()+"</expire_password_when>";

	if(panelRestrictions._panel.find("#ipRestrictionsCheck").find("input:checked").length>0)
	{
		xml += "\r\n<ip_restrictions type=\"vector\">";
		$("#IPRestrictions", panelRestrictions._panel).find("li").each(function(){
			var curItem = $(this).data("controlData");
			var type = curItem.type;
			var startip = curItem.start_ip;
			var stopip = curItem.stop_ip;
			xml += "\r\n<ip_restrictions_subitem type=\"properties\">";
			xml += "\r\n<stop_ip>"+stopip+"</stop_ip>";
			xml += "\r\n<start_ip>"+startip+"</start_ip>";
			xml += "\r\n<type>"+type+"</type>";
			xml += "\r\n</ip_restrictions_subitem>";
		});
		xml += "\r\n</ip_restrictions>";
	}

	if(panelRestrictions._panel.find("#allowedConnectionDaysCheck").find("input:checked").length>0)
	{
		xml += "\r\n<day_of_week_allow>";
		panelRestrictions._panel.find("#dayOfWeekAllowedToConnect").find("input:checked").each(function(){
			xml += $(this).attr("id").replace("day","");
		});
		xml += "</day_of_week_allow>";
	}

	if(panelRestrictions._panel.find("#connectionsPerProtocolCheck").find("input:checked").length>0)
	{
		xml += "\r\n<allowed_protocols>";
		var settingPanel = panelRestrictions._panel.find("#maxConnectionsPerProtocolSettings");
		var proto_http = $("#proto_http", settingPanel).is(":checked");
		settingPanel.find("input:checked").each(function(){
			var proto = $(this).attr("id").replace("proto_","").toLowerCase();
			if(proto == "https" || proto == "webdav")
			{
				if(proto_http)
				{
					var val = settingPanel.find("#proto_3_c").val() ;
					if($.trim(val) == "") val = 0;
					xml += $(this).attr("id").replace("proto_","") + ":" + val + ",";
				}
			}
			else
			{
				var val = $(this).closest("td").find("input[type='text']").val();
				if($.trim(val) == "") val = 0;
				xml += $(this).attr("id").replace("proto_","") + ":" + val + ",";
			}
		});
		xml += "</allowed_protocols>";
	}

	return xml;
}